## Xalan-C++ API Documentation

### The Xalan C++ XSLT Processor Version 1.5

Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members

# Stylesheet Class Reference

This class represents the base stylesheet or an "import" stylesheet. More...

`#include <Stylesheet.hpp>`

Inheritance diagram for Stylesheet:

[legend]
Collaboration diagram for Stylesheet:

[legend]
List of all members.

## Public Types

- typedef size_t size_type
- typedef StylesheetExecutionContext::ParamVectorType ParamVectorType
- typedef XalanQName::NamespaceVectorType NamespaceVectorType
- typedef XalanQName::NamespacesStackType NamespacesStackType
- typedef std::map<XalanDOMString,
  ExtensionNSHandler*> ExtensionNamespacesMapType
- typedef std::map<XalanQNameByReference,
  const ElemTemplate*, std::less<
  XalanQName> > ElemTemplateMapType
- typedef std::vector<ElemAttributeSet*> AttributeSetVectorType
- typedef std::vector<ElemVariable*> ElemVariableVectorType
- typedef std::vector<KeyDeclaration> KeyDeclarationVectorType
- typedef std::map<const XalanNode*,
  KeyTable*> KeyTablesTableType
- typedef std::vector<Stylesheet*> StylesheetVectorType
- typedef std::vector<XalanDOMString> URLStackType
- typedef std::vector<ElemDecimalFormat*> ElemDecimalFormatVectorType
- typedef std::vector<const
  MatchPattern2*> PatternTableVectorType
- typedef std::map<XalanDOMString,
  PatternTableVectorType> PatternTableMapType
- typedef std::deque<MatchPattern2> MatchPattern2Container

## Public Methods

- Stylesheet (StylesheetRoot &root, const XalanDOMString &baseIdentifier, StylesheetConstructionContext &constructionContext)
    Constructor for a Stylesheet needs a Document. More...
- virtual ~Stylesheet ()
- double getXSLTVerDeclared () const
    Retrieve XSLT version number. More...
- void setXSLTVerDeclared (double ver)
    Set XSLT version number. More...
- const StylesheetRoot& getStylesheetRoot () const
    Retrieve the root stylesheet object. More...
- StylesheetRoot& getStylesheetRoot ()
    Retrieve the root stylesheet object. More...
- const NamespacesStackType& getNamespaces () const
    Retrieve the stack of namespace lists. More...
- NamespacesStackType& getNamespaces ()
    Retrieve the stack of namespace lists. More...
- const NamespacesHandler& getNamespacesHandler () const
- NamespacesHandler& getNamespacesHandler ()
- const NamespaceVectorType& getNamespaceDecls () const
    Retrieve the list of namespace declarations currently in effect. More...
- NamespaceVectorType& getNamespaceDecls ()
    Retrieve the list of namespace declarations currently in effect. More...
- void setNamespaceDecls (const NamespaceVectorType &ns)
    Set the list of namespace declarations currently in effect. More...
- void pushNamespaces (const AttributeListType &atts)
    Push the namespace declarations from the current attribute list onto the namespace stack. More...
- void popNamespaces ()
    Pop a namespace declaration from the namespace stack. More...
- virtual void postConstruction (StylesheetConstructionContext &constructionContext)
    Called after construction is completed. More...
- bool isAttrOK (const XalanDOMChar *attrName, const AttributeListType &atts, int which, StylesheetConstructionContext &constructionContext) const
    See if this is a xmlns attribute, and, if so, process it. More...
- const XalanDOMString* getNamespaceFromStack (const XalanDOMString &nodeName) const
    Get the namespace from a qualified name. More...
- const XalanDOMString* getNamespaceFromStack (const XalanDOMChar *nodeName) const
    Get the namespace from a qualified name. More...
- const XalanDOMString* getNamespaceForPrefixFromStack (const XalanDOMString &prefix) const
    Get the namespace from a prefix by searching the stack of namespace lists. More...
- const XalanDOMString* getNamespaceForPrefixFromStack (const XalanDOMChar *prefix) const
    Get the namespace from a prefix by searching the stack of namespace lists. More...
- void processExcludeResultPrefixes (StylesheetConstructionContext &theConstructionContext, const XalanDOMChar *theValue)
    See if a namespace should be excluded. More...
- void addTemplate (ElemTemplate *theTemplate, StylesheetConstructionContext &constructionContext)
    Add a template to the list of names templates. More...
- bool getYesOrNo (const XalanDOMChar *aname, const XalanDOMChar *val, StylesheetConstructionContext &constructionContext) const
    Process an attribute that has the value of 'yes' or 'no'. More...
- bool isRoot () const
    Tell if this is the root of the stylesheet tree. More...
- const XalanDOMString& getBaseIdentifier () const
    Retrieve the base identifier with which this stylesheet is associated. More...
- void setBaseIdentifier (const XalanDOMString &str)
    Set the base identifier with which this stylesheet is associated. More...
- const XalanDOMString& getCurrentIncludeBaseIdentifier () const
    Retrieve the base identifier for the most recently included stylesheet. More...
- void processNSAliasElement (const XalanDOMChar *name, const AttributeListType &atts, StylesheetConstructionContext &constructionContext)
    Process an xsl:namespace-alias element. More...
- void processDecimalFormatElement (StylesheetConstructionContext &constructionContext, const AttributeListType &atts, const LocatorType *locator=0)
    Process an xsl:decimal-format element. More...
- const XalanDecimalFormatSymbols* getDecimalFormatSymbols (const XalanQName &theQName) const
    Retrieve the XalanDecimalFormatSymbols instance associated with the QName. More...
- void addAttributeSet (ElemAttributeSet *attrSet)
    Add an attribute set to the list. More...
- void applyAttrSets (const XalanQName **attributeSetsNames, size_type attributeSetsNamesCount, StylesheetExecutionContext &executionContext, XalanNode *sourceNode) const
    Apply the set of named attributes to a node in a given context with a given mode. More...
- void addImport (Stylesheet *theStylesheet)
    Add an imported stylesheet. More...
- bool isWrapperless () const
    whether there is a wrapper template. More...
- ElemTemplateElement* initWrapperless (StylesheetConstructionContext &constructionContext, const LocatorType *locator)
- URLStackType& getIncludeStack ()
    Retrieve the stack of who's including who. More...
- void processKeyElement (const PrefixResolver &nsContext, const AttributeListType &atts, const LocatorType *locator, StylesheetConstructionContext &constructionContext)
    Process the xsl:key element. More...
- const ElemTemplate* findNamedTemplate (const XalanQName &qname) const
    Locate a template via the "name" attribute. More...
- const ElemTemplate* findTemplate (StylesheetExecutionContext &executionContext, XalanNode *targetNode) const
    Given a target element, find the template that best matches in the given XSL document, according to the rules specified in the xsl draft. More...
- const ElemTemplate* findTemplate (StylesheetExecutionContext &executionContext, XalanNode *targetNode, XalanNode::NodeType targetNodeType, const XalanQName &mode, bool onlyUseImports) const
    Given a target element, find the template that best matches in the given XSL document, according to the rules specified in the xsl draft. More...
- const PatternTableVectorType* locateElementMatchPatternList2 (const XalanDOMString &theName) const
    Given a name, locate the start of a list of possible templates that match that name. More...
- const PatternTableVectorType* locateAttributeMatchPatternList2 (const XalanDOMString &theName) const
    Given a name, locate the start of a list of possible templates that match that name. More...
- const PatternTableVectorType* locateMatchPatternList2 (const XalanNode &theNode, XalanNode::NodeType targetNodeType) const
    Given a XalanNode, locate the start of a list of possible templates that match it. More...
- void processExtensionNamespace (StylesheetConstructionContext &theConstructionContext, const XalanDOMString &uri)
    Add an extension namespace handler. More...
- ExtensionNSHandler* lookupExtensionNSHandler (const XalanDOMString &uri) const
    Return the handler for a given extension namespace. More...
- void setTopLevelVariable (ElemVariable *var)
    Set a top level variable. More...
- void pushTopLevelVariables (StylesheetExecutionContext &executionContext, const ParamVectorType &topLevelParams) const
    Set a list of top level variables in the specified execution context stylesheet. More...
- virtual const XalanDOMString& getNodeName () const
- virtual const XalanDOMString& getNodeValue () const
    Gets the value of this node, depending on its type. More...
- virtual NodeType getNodeType () const
    An enum value representing the type of the underlying object. More...
- virtual XalanNode* getParentNode () const
    Gets the parent of this node. More...
- virtual const XalanNodeList* getChildNodes () const
    Gets a `NodeList` that contains all children of this node. More...
- virtual XalanNode* getFirstChild () const
    Gets the first child of this node. More...
- virtual XalanNode* getLastChild () const
    Gets the last child of this node. More...
- virtual XalanNode* getPreviousSibling () const
    Gets the node immediately preceding this node. More...
- virtual XalanNode* getNextSibling () const
    Gets the node immediately following this node. More...
- virtual const XalanNamedNodeMap* getAttributes () const
    Gets a `NamedNodeMap` containing the attributes of this node (if it is an `Element`) or `null` otherwise. More...
- virtual XalanDocument* getOwnerDocument () const
    Gets the `Document` object associated with this node. More...
- virtual Stylesheet* cloneNode (bool deep) const
    Returns a duplicate of this node. More...
- virtual XalanNode* insertBefore (XalanNode *newChild, XalanNode *refChild)
    Inserts the node `newChild` before the existing child node `refChild`. More...
- virtual XalanNode* replaceChild (XalanNode *newChild, XalanNode *oldChild)
    Replaces the child node `oldChild` with `newChild` in the list of children, and returns the `oldChild` node. More...
- virtual XalanNode* removeChild (XalanNode *oldChild)
    Removes the child node indicated by `oldChild` from the list of children, and returns it. More...
- virtual XalanNode* appendChild (XalanNode *newChild)
    Adds the node `newChild` to the end of the list of children of this node. More...
- virtual bool hasChildNodes () const
    This is a convenience method to allow easy determination of whether a node has any children. More...
- virtual void setNodeValue (const XalanDOMString &nodeValue)
    Sets the value of the node. More...
- virtual void normalize ()
    Puts all `Text` nodes in the full depth of the sub-tree underneath this `Node`, including attribute nodes, into a "normal" form where only markup (e.g., tags, comments, processing instructions, CDATA sections, and entity references) separates `Text` nodes, i.e., there are no adjacent `Text` nodes. More...
- virtual bool isSupported (const XalanDOMString &feature, const XalanDOMString &version) const
    Tests whether the DOM implementation implements a specific feature and that feature is supported by this node. More...
- virtual const XalanDOMString& getNamespaceURI () const
    Get the namespace URI of this node, or `null` if it is unspecified. More...
- virtual const XalanDOMString& getPrefix () const
    Get the namespace prefix of this node, or `null` if it is unspecified. More...
- virtual const XalanDOMString& getLocalName () const
    Returns the local part of the qualified name of this node. More...
- virtual void setPrefix (const XalanDOMString &prefix)
    Set the namespace prefix of this node. More...
- virtual IndexType getIndex () const
    Get the node's index. More...
- virtual XalanElement* createElement (const XalanDOMString &tagName)
    Creates an element of the type specified. More...
- virtual XalanDocumentFragment* createDocumentFragment ()
    Creates an empty DocumentFragment object. More...
- virtual XalanText* createTextNode (const XalanDOMString &data)
    Creates a Text node given the specified string. More...
- virtual XalanComment* createComment (const XalanDOMString &data)
    Creates a Comment node given the specified string. More...
- virtual XalanCDATASection* createCDATASection (const XalanDOMString &data)
    Creates a CDATASection node whose value is the specified string. More...
- virtual XalanProcessingInstruction* createProcessingInstruction (const XalanDOMString &target, const XalanDOMString &data)
    Creates a ProcessingInstruction node given the specified name and data strings. More...
- virtual XalanAttr* createAttribute (const XalanDOMString &name)
    Creates an Attr of the given name. More...
- virtual XalanEntityReference* createEntityReference (const XalanDOMString &name)
    Creates an EntityReference object. More...
- virtual XalanDocumentType* getDoctype () const
    Get Document Type Declaration (see `DocumentType`) associated with this document. More...
- virtual XalanDOMImplementation* getImplementation () const
    Return the `DOMImplementation` object that handles this document. More...
- virtual XalanElement* getDocumentElement () const
    Return a reference to the root element of the document. More...
- virtual XalanNodeList* getElementsByTagName (const XalanDOMString &tagname) const
    Returns a `NodeList` of all the elements with a given tag name. More...
- virtual XalanNode* importNode (XalanNode *importedNode, bool deep)
    Imports a node from another document to this document. More...
- virtual XalanElement* createElementNS (const XalanDOMString &namespaceURI, const XalanDOMString &qualifiedName)
    Creates an element of the given qualified name and namespace URI. More...
- virtual XalanAttr* createAttributeNS (const XalanDOMString &namespaceURI, const XalanDOMString &qualifiedName)
    Creates an attribute of the given qualified name and namespace URI. More...
- virtual XalanNodeList* getElementsByTagNameNS (const XalanDOMString &namespaceURI, const XalanDOMString &localName) const
    Returns a `NodeList` of all the `Element`s with a given local name and namespace URI in the order in which they would be encountered in a preorder traversal of the `Document` tree. More...
- virtual XalanElement* getElementById (const XalanDOMString &elementId) const
    Returns the `Element` whose ID is given by `elementId`. More...
- virtual bool isIndexed () const
    Determine if the document is node-order indexed. More...
- virtual const XalanDOMString* getNamespaceForPrefix (const XalanDOMString &prefix) const
    Retrieve a namespace corresponding to a prefix. More...
- virtual const XalanDOMString& getURI () const
    Retrieve the base URI for the resolver. More...
- const XalanDOMString& getXSLTNamespaceURI () const
- void setXSLTNamespaceURI (const XalanDOMString &theURI)

## Static Public Methods

- void addObjectIfNotFound (const MatchPattern2 *thePattern, PatternTableVectorType &theVector)
    Add object to vector of match patterns if not already there. More...
- void addObjectIfNotFound (const MatchPattern2 *thePattern, const MatchPattern2 *theArray[], unsigned int &theArraySize)
    Add object to array of match patterns if not already there. More...

## Protected Attributes

- StylesheetRoot& m_stylesheetRoot
    The root of the stylesheet tree. More...
- XalanDOMString m_baseIdent
    The base URL of the XSL document. More...
- KeyDeclarationVectorType m_keyDeclarations
    Table of KeyDeclaration objects, which are set by the xsl:key element. More...

## Static Protected Attributes

- const XalanQNameByReference s_emptyQName

## Detailed Description

This class represents the base stylesheet or an "import" stylesheet.

"include" stylesheets are combined with the including stylesheet.

## Member Typedef Documentation

typedef std::vector< ElemAttributeSet *> Stylesheet::AttributeSetVectorType<ElemAttributeSet*>

typedef std::vector< ElemDecimalFormat *> Stylesheet::ElemDecimalFormatVectorType<ElemDecimalFormat*>

typedef std::map< XalanQNameByReference, const ElemTemplate *, std::less< XalanQName > > Stylesheet::ElemTemplateMapType<XalanQNameByReference, const ElemTemplate*, std::less<XalanQName> >

typedef std::vector< ElemVariable *> Stylesheet::ElemVariableVectorType<ElemVariable*>

typedef std::map< XalanDOMString, ExtensionNSHandler *> Stylesheet::ExtensionNamespacesMapType<XalanDOMString, ExtensionNSHandler*>

typedef std::vector< KeyDeclaration > Stylesheet::KeyDeclarationVectorType<KeyDeclaration>

typedef std::map< const XalanNode *, KeyTable *> Stylesheet::KeyTablesTableType<const XalanNode*, KeyTable*>

typedef std::deque< MatchPattern2 > Stylesheet::MatchPattern2Container<MatchPattern2>

typedef XalanQName::NamespaceVectorType Stylesheet::NamespaceVectorType

typedef XalanQName::NamespacesStackType Stylesheet::NamespacesStackType

typedef StylesheetExecutionContext::ParamVectorType Stylesheet::ParamVectorType

typedef std::map< XalanDOMString, PatternTableVectorType > Stylesheet::PatternTableMapType<XalanDOMString, PatternTableVectorType>

typedef std::vector< const MatchPattern2 *> Stylesheet::PatternTableVectorType<const MatchPattern2*>

typedef std::vector< Stylesheet *> Stylesheet::StylesheetVectorType<Stylesheet*>

typedef std::vector< XalanDOMString > Stylesheet::URLStackType<XalanDOMString>

typedef size_t Stylesheet::size_type

## Constructor & Destructor Documentation

Stylesheet::Stylesheet ( | StylesheetRoot & root,
| const XalanDOMString & baseIdentifier,
| StylesheetConstructionContext & constructionContext )

  | Constructor for a Stylesheet needs a Document. Exceptions:
  XSLProcessorException | thrown if the active ProblemListener and XMLParserLiaison decide the error condition is severe enough to halt processing.

Stylesheet::~Stylesheet ( | )`[virtual]`

## Member Function Documentation

void Stylesheet::addAttributeSet ( | ElemAttributeSet * attrSet )

  | Add an attribute set to the list. Parameters:
  attrSet | pointer to attribute set to add

void Stylesheet::addImport ( | Stylesheet * theStylesheet )

  | Add an imported stylesheet. Parameters:
  theStylesheet | The stylesheet to add.

void Stylesheet::addObjectIfNotFound ( | const MatchPattern2 * thePattern,
| const MatchPattern2 * theArray[],
| unsigned int & theArraySize )`[static]`

  | Add object to array of match patterns if not already there. theArraySize size will be incremented if the pattern was added. Parameters:
  thePattern | pattern to add
  theArray | vector of patterns to add to
  theArraySize | The size of the array

void Stylesheet::addObjectIfNotFound ( | const MatchPattern2 * thePattern,
| PatternTableVectorType & theVector )`[static]`

  | Add object to vector of match patterns if not already there. Parameters:
  thePattern | pattern to add
  theVector | vector of patterns to add to

void Stylesheet::addTemplate ( | ElemTemplate * theTemplate,
| StylesheetConstructionContext & constructionContext )

  | Add a template to the list of names templates. Parameters:
  theTemplate | template to add
  constructionContext | context for construction

XalanNode * Stylesheet::appendChild ( | XalanNode * newChild )`[virtual]`

  | Adds the node `newChild` to the end of the list of children of this node. If the `newChild` is already in the tree, it is first removed. Parameters:
  newChild | The node to add.If it is a `DocumentFragment` object, the entire contents of the document fragment are moved into the child list of this node
Returns: The node added. Reimplemented from XalanDocument.

void Stylesheet::applyAttrSets ( | const XalanQName ** attributeSetsNames,
| size_type attributeSetsNamesCount,
| StylesheetExecutionContext & executionContext,
| XalanNode * sourceNode ) const

  | Apply the set of named attributes to a node in a given context with a given mode. Parameters:
  attributeSetsNames | The vector of attribute set names
  attributeSetsNamesCount | The size of the vector
  executionContext | The current execution context
  sourceNode | The source node

Stylesheet * Stylesheet::cloneNode ( | bool deep ) const`[virtual]`

  | Returns a duplicate of this node. This function serves as a generic copy constructor for nodes. The duplicate node has no parent ( `parentNode` returns `null`.). Cloning an `Element` copies all attributes and their values, including those generated by the XML processor to represent defaulted attributes, but this method does not copy any text it contains unless it is a deep clone, since the text is contained in a child `Text` node. Cloning any other type of node simply returns a copy of this node. Parameters:
  deep | If `true`, recursively clone the subtree under the specified node; if `false`, clone only the node itself (and its attributes, if it is an `Element`).
Returns: The duplicate node. Reimplemented from XalanDocument.

XalanAttr * Stylesheet::createAttribute ( | const XalanDOMString & name )`[virtual]`

  | Creates an Attr of the given name. Note that the `Attr` instance can then be attached to an Element using the `DOMElement::setAttribute()` method. Parameters:
  name | The name of the attribute.
  Returns: A new `Attr` object with the `nodeName` attribute set to `name`, and `localName`, `prefix`, and `namespaceURI` set to `null`. Exceptions:
  DOMException | INVALID_CHARACTER_ERR: Raised if the specified name contains an illegal character.
Reimplemented from XalanDocument.

XalanAttr * Stylesheet::createAttributeNS ( | const XalanDOMString & namespaceURI,
| const XalanDOMString & qualifiedName )`[virtual]`

  | Creates an attribute of the given qualified name and namespace URI. "Experimental - subject to change" Parameters:
  namespaceURI | The namespace URI of the attribute to create.
  qualifiedName | The qualified name of the attribute to instantiate.
  Returns: A new `Attr` object. Exceptions:
  DOMException | INVALID_CHARACTER_ERR: Raised if the specified qualified name contains an illegal character. NAMESPACE_ERR: Raised if the `qualifiedName` is malformed, if the `qualifiedName` has a prefix and the `namespaceURI` is `null` or an empty string, if the `qualifiedName` has a prefix that is "xml" and the `namespaceURI` is different from "http://www.w3.org/XML/1998/namespace", if the `qualifiedName` has a prefix that is "xmlns" and the `namespaceURI` is different from "http://www.w3.org/2000/xmlns/", or if the `qualifiedName` is "xmlns" and the `namespaceURI` is different from "http://www.w3.org/2000/xmlns/".
Reimplemented from XalanDocument.

XalanCDATASection * Stylesheet::createCDATASection ( | const XalanDOMString & data )`[virtual]`

  | Creates a CDATASection node whose value is the specified string. Parameters:
  data | The data for the `CDATASection` contents.
  Returns: A `CDATASection` object. Exceptions:
  DOMException | NOT_SUPPORTED_ERR: Raised if this document is an HTML document.
Reimplemented from XalanDocument.

XalanComment * Stylesheet::createComment ( | const XalanDOMString & data )`[virtual]`

  | Creates a Comment node given the specified string. Parameters:
  data | The data for the comment.
Returns: A `Comment` that references the newly created comment node. Reimplemented from XalanDocument.

XalanDocumentFragment * Stylesheet::createDocumentFragment ( | )`[virtual]`

| Creates an empty DocumentFragment object. Returns: A `DocumentFragment` that references the newly created document fragment. Reimplemented from XalanDocument.

XalanElement * Stylesheet::createElement ( | const XalanDOMString & tagName )`[virtual]`

  | Creates an element of the type specified. Note that the instance returned implements the Element interface, so attributes can be specified directly on the returned object. Parameters:
  tagName | The name of the element type to instantiate.
Returns: A `Element` that reference the new element. Reimplemented from XalanDocument.

XalanElement * Stylesheet::createElementNS ( | const XalanDOMString & namespaceURI,
| const XalanDOMString & qualifiedName )`[virtual]`

  | Creates an element of the given qualified name and namespace URI. "Experimental - subject to change" Parameters:
  namespaceURI | The namespace URI of the element to create.
  qualifiedName | The qualified name of the element type to instantiate.
  Returns: A new `Element` object. Exceptions:
  DOMException | INVALID_CHARACTER_ERR: Raised if the specified qualified name contains an illegal character. NAMESPACE_ERR: Raised if the `qualifiedName` is malformed, if the `qualifiedName` has a prefix and the `namespaceURI` is `null` or an empty string, or if the `qualifiedName` has a prefix that is "xml" and the `namespaceURI` is different from "http://www.w3.org/XML/1998/namespace".
Reimplemented from XalanDocument.

XalanEntityReference * Stylesheet::createEntityReference ( | const XalanDOMString & name )`[virtual]`

  | Creates an EntityReference object. Parameters:
  name | The name of the entity to reference.
  Returns: A `EntityReference` that references the newly created EntityReference node. Exceptions:
  DOMException | INVALID_CHARACTER_ERR: Raised if the specified name contains an illegal character.
Reimplemented from XalanDocument.

XalanProcessingInstruction * Stylesheet::createProcessingInstruction ( | const XalanDOMString & target,
| const XalanDOMString & data )`[virtual]`

  | Creates a ProcessingInstruction node given the specified name and data strings. Parameters:
  target | The target part of the processing instruction.
  data | The data for the node.
  Returns: A `ProcessingInstruction` that references the newly created PI node. Exceptions:
  DOMException | INVALID_CHARACTER_ERR: Raised if an illegal character is specified.
Reimplemented from XalanDocument.

XalanText * Stylesheet::createTextNode ( | const XalanDOMString & data )`[virtual]`

  | Creates a Text node given the specified string. Parameters:
  data | The data for the node.
Returns: A `Text` object that references the newly created text node. Reimplemented from XalanDocument.

const ElemTemplate * Stylesheet::findNamedTemplate ( | const XalanQName & qname ) const

  | Locate a template via the "name" attribute. Parameters:
  name | qualified name of template
Returns: pointer to template found or 0 if none found

const ElemTemplate * Stylesheet::findTemplate ( | StylesheetExecutionContext & executionContext,
| XalanNode * targetNode,
| XalanNode::NodeType targetNodeType,
| const XalanQName & mode,
| bool onlyUseImports ) const

  | Given a target element, find the template that best matches in the given XSL document, according to the rules specified in the xsl draft. Parameters:
  executionContext | current execution context
  targetNode | node that needs a rule
  targetNodeType | the type of targetNode
  mode | string indicating the mode
  onlyUseImports | only use imports, do not use any templates from the stylesheet itself
Returns: pointer to rule that best matches targetElem

const ElemTemplate * Stylesheet::findTemplate ( | StylesheetExecutionContext & executionContext,
| XalanNode * targetNode ) const

  | Given a target element, find the template that best matches in the given XSL document, according to the rules specified in the xsl draft. Parameters:
  executionContext | current execution context
  targetNode | element that needs a rule
Returns: pointer to rule that best matches targetNode

const XalanNamedNodeMap * Stylesheet::getAttributes ( | ) const`[virtual]`

| Gets a `NamedNodeMap` containing the attributes of this node (if it is an `Element`) or `null` otherwise. Reimplemented from XalanDocument.

const XalanDOMString & Stylesheet::getBaseIdentifier ( | ) const

| Retrieve the base identifier with which this stylesheet is associated. Returns: string for base identifier

const XalanNodeList * Stylesheet::getChildNodes ( | ) const`[virtual]`

| Gets a `NodeList` that contains all children of this node. If there are no children, this is a `NodeList` containing no nodes. The content of the returned `NodeList` is "live" in the sense that, for instance, changes to the children of the node object that it was created from are immediately reflected in the nodes returned by the `NodeList` accessors; it is not a static snapshot of the content of the node. This is true for every `NodeList`, including the ones returned by the `getElementsByTagName` method. Reimplemented from XalanDocument.

const XalanDOMString & Stylesheet::getCurrentIncludeBaseIdentifier ( | ) const

| Retrieve the base identifier for the most recently included stylesheet. This will return the same value as getBaseIdentifier(), if no include is being processed. Returns: string for base identifier

const XalanDecimalFormatSymbols * Stylesheet::getDecimalFormatSymbols ( | const XalanQName & theQName ) const

  | Retrieve the XalanDecimalFormatSymbols instance associated with the QName. Parameters:
  theQName | the QName for the lookup
Returns: a pointer to the matching instance, or 0 if none was found

XalanDocumentType * Stylesheet::getDoctype ( | ) const`[virtual]`

| Get Document Type Declaration (see `DocumentType`) associated with this document. For documents without a document type declaration this returns `null` reference object. The DOM Level 1 does not support editing the Document Type Declaration, therefore `docType` cannot be altered in any way. Reimplemented from XalanDocument.

XalanElement * Stylesheet::getDocumentElement ( | ) const`[virtual]`

| Return a reference to the root element of the document. Reimplemented from XalanDocument.

XalanElement * Stylesheet::getElementById ( | const XalanDOMString & elementId ) const`[virtual]`

  | Returns the `Element` whose ID is given by `elementId`. If no such element exists, returns `null`. Behavior is not defined if more than one element has this `ID`. Note: The DOM implementation must have information that says which attributes are of type ID. Attributes with the name "ID" are not of type ID unless so defined. Implementations that do not know whether attributes are of type ID or not are expected to return `null`. "Experimental - subject to change" Parameters:
  elementId | The unique `id` value for an element.
Returns: The matching element. Reimplemented from XalanDocument.

XalanNodeList * Stylesheet::getElementsByTagName ( | const XalanDOMString & tagname ) const`[virtual]`

  | Returns a `NodeList` of all the elements with a given tag name. The returned node list is "live", in that changes to the document tree made after a nodelist was initially returned will be immediately reflected in the node list. The elements in the node list are ordered in the same order in which they would be encountered in a preorder traversal of the `Document` tree. Parameters:
  tagname | The name of the tag to match on. The special value "*" matches all tags.
Returns: A reference to a NodeList containing all the matched `Element`s. Reimplemented from XalanDocument.

XalanNodeList * Stylesheet::getElementsByTagNameNS ( | const XalanDOMString & namespaceURI,
| const XalanDOMString & localName ) const`[virtual]`

  | Returns a `NodeList` of all the `Element`s with a given local name and namespace URI in the order in which they would be encountered in a preorder traversal of the `Document` tree. "Experimental - subject to change" Parameters:
  namespaceURI | The namespace URI of the elements to match on. The special value "*" matches all namespaces.
  localName | The local name of the elements to match on. The special value "*" matches all local names.
Returns: A new `NodeList` object containing all the matched `Element`s. Reimplemented from XalanDocument.

XalanNode * Stylesheet::getFirstChild ( | ) const`[virtual]`

| Gets the first child of this node. If there is no such node, this returns `null`. Reimplemented from XalanDocument.

XalanDOMImplementation * Stylesheet::getImplementation ( | ) const`[virtual]`

| Return the `DOMImplementation` object that handles this document. Reimplemented from XalanDocument.

URLStackType & Stylesheet::getIncludeStack ( | )

| Retrieve the stack of who's including who. Returns: stack of includes

IndexType Stylesheet::getIndex ( | ) const`[virtual]`

| Get the node's index. Valid only if isIndexed() reports that the document is node-order indexed. Returns: The index value, or 0 if the node is not indexed. Reimplemented from XalanDocument.

XalanNode * Stylesheet::getLastChild ( | ) const`[virtual]`

| Gets the last child of this node. If there is no such node, this returns `null`. Reimplemented from XalanDocument.

const XalanDOMString & Stylesheet::getLocalName ( | ) const`[virtual]`

| Returns the local part of the qualified name of this node. For nodes created with a DOM Level 1 method, such as `createElement` from the `Document` interface, it is null. Reimplemented from XalanDocument.

NamespaceVectorType & Stylesheet::getNamespaceDecls ( | )

| Retrieve the list of namespace declarations currently in effect. Returns: vector of namespace vectors

const NamespaceVectorType & Stylesheet::getNamespaceDecls ( | ) const

| Retrieve the list of namespace declarations currently in effect. Returns: vector of namespace vectors

const XalanDOMString * Stylesheet::getNamespaceForPrefix ( | const XalanDOMString & prefix ) const`[virtual]`

  | Retrieve a namespace corresponding to a prefix. This assumes that the PrevixResolver holds its own namespace context, or is a namespace context itself. Parameters:
  prefix | Prefix to resolve
Returns: namespace that prefix resolves to, or null if prefix is not found Reimplemented from PrefixResolver.

const XalanDOMString * Stylesheet::getNamespaceForPrefixFromStack ( | const XalanDOMChar * prefix ) const

  | Get the namespace from a prefix by searching the stack of namespace lists. Parameters:
  prefix | prefix to search
Returns: namespace corresponding to prefix, or null if not found.

const XalanDOMString * Stylesheet::getNamespaceForPrefixFromStack ( | const XalanDOMString & prefix ) const

  | Get the namespace from a prefix by searching the stack of namespace lists. Parameters:
  prefix | prefix to search
Returns: namespace corresponding to prefix, or null if not found.

const XalanDOMString * Stylesheet::getNamespaceFromStack ( | const XalanDOMChar * nodeName ) const

  | Get the namespace from a qualified name. Parameters:
  nodeName | name of node
Returns: namespace string for node, or null if not found.

const XalanDOMString * Stylesheet::getNamespaceFromStack ( | const XalanDOMString & nodeName ) const

  | Get the namespace from a qualified name. Parameters:
  nodeName | name of node
Returns: namespace string for node, or null if not found.

const XalanDOMString & Stylesheet::getNamespaceURI ( | ) const`[virtual]`

| Get the namespace URI of this node, or `null` if it is unspecified. This is not a computed value that is the result of a namespace lookup based on an examination of the namespace declarations in scope. It is merely the namespace URI given at creation time. For nodes of any type other than `ELEMENT_NODE` and `ATTRIBUTE_NODE` and nodes created with a DOM Level 1 method, such as `createElement` from the `Document` interface, this is always `null`. Reimplemented from XalanDocument.

NamespacesStackType & Stylesheet::getNamespaces ( | )

| Retrieve the stack of namespace lists. Returns: vector of namespace vectors

const NamespacesStackType & Stylesheet::getNamespaces ( | ) const

| Retrieve the stack of namespace lists. Returns: vector of namespace vectors

NamespacesHandler & Stylesheet::getNamespacesHandler ( | )

const NamespacesHandler & Stylesheet::getNamespacesHandler ( | ) const

XalanNode * Stylesheet::getNextSibling ( | ) const`[virtual]`

| Gets the node immediately following this node. If there is no such node, this returns `null`. Reimplemented from XalanDocument.

const XalanDOMString & Stylesheet::getNodeName ( | ) const`[virtual]`

| Reimplemented from XalanDocument.

NodeType Stylesheet::getNodeType ( | ) const`[virtual]`

| An enum value representing the type of the underlying object. Reimplemented from XalanDocument.

const XalanDOMString & Stylesheet::getNodeValue ( | ) const`[virtual]`

| Gets the value of this node, depending on its type. Reimplemented from XalanDocument.

XalanDocument * Stylesheet::getOwnerDocument ( | ) const`[virtual]`

| Gets the `Document` object associated with this node. This is also the `Document` object used to create new nodes. When this node is a `Document` or a `DocumentType` which is not used with any `Document` yet, this is `null`. Reimplemented from XalanDocument.

XalanNode * Stylesheet::getParentNode ( | ) const`[virtual]`

| Gets the parent of this node. All nodes, except `Document`, `DocumentFragment`, and `Attr` may have a parent. However, if a node has just been created and not yet added to the tree, or if it has been removed from the tree, a `null` Node is returned. Reimplemented from XalanDocument.

const XalanDOMString & Stylesheet::getPrefix ( | ) const`[virtual]`

| Get the namespace prefix of this node, or `null` if it is unspecified. Reimplemented from XalanDocument.

XalanNode * Stylesheet::getPreviousSibling ( | ) const`[virtual]`

| Gets the node immediately preceding this node. If there is no such node, this returns `null`. Reimplemented from XalanDocument.

StylesheetRoot & Stylesheet::getStylesheetRoot ( | )

| Retrieve the root stylesheet object. Returns: reference to the stylesheet object

const StylesheetRoot & Stylesheet::getStylesheetRoot ( | ) const

| Retrieve the root stylesheet object. Returns: const reference to the stylesheet object

const XalanDOMString & Stylesheet::getURI ( | ) const`[virtual]`

| Retrieve the base URI for the resolver. Returns: URI string Reimplemented from PrefixResolver.

const XalanDOMString & Stylesheet::getXSLTNamespaceURI ( | ) const

double Stylesheet::getXSLTVerDeclared ( | ) const

| Retrieve XSLT version number. Returns: number representing XSLT version

bool Stylesheet::getYesOrNo ( | const XalanDOMChar * aname,
| const XalanDOMChar * val,
| StylesheetConstructionContext & constructionContext ) const

  | Process an attribute that has the value of 'yes' or 'no'. Parameters:
  aname | name of attribute
  val | value
  constructionContext | context for construction
Returns: true if value equals string constant for "yes," false otherwise

bool Stylesheet::hasChildNodes ( | ) const`[virtual]`

| This is a convenience method to allow easy determination of whether a node has any children. Returns: `true` if the node has any children, `false` if the node has no children. Reimplemented from XalanDocument.

XalanNode * Stylesheet::importNode ( | XalanNode * importedNode,
| bool deep )`[virtual]`

  | Imports a node from another document to this document. The returned node has no parent (`parentNode` is `null`). The source node is not altered or removed from the original document; this method creates a new copy of the source node. For all nodes, importing a node creates a node object owned by the importing document, with attribute values identical to the source node's `nodeName` and `nodeType`, plus the attributes related to namespaces (prefix and namespaces URI). "Experimental - subject to change" Parameters:
  importedNode | The node to import.
  deep | If `true`, recursively import the subtree under the specified node; if `false`, import only the node itself, as explained above. This does not apply to `Attr`, `EntityReference`, and `Notation` nodes.
  Returns: The imported node that belongs to this `Document`. Exceptions:
  DOMException | NOT_SUPPORTED_ERR: Raised if the type of node being imported is not supported.
Reimplemented from XalanDocument.

ElemTemplateElement * Stylesheet::initWrapperless ( | StylesheetConstructionContext & constructionContext,
| const LocatorType * locator )

XalanNode * Stylesheet::insertBefore ( | XalanNode * newChild,
| XalanNode * refChild )`[virtual]`

  | Inserts the node `newChild` before the existing child node `refChild`. If `refChild` is `null`, insert `newChild` at the end of the list of children. If `newChild` is a `DocumentFragment` object, all of its children are inserted, in the same order, before `refChild`. If the `newChild` is already in the tree, it is first removed. Note that a `Node` that has never been assigned to refer to an actual node is == null. Parameters:
  newChild | The node to insert.
  refChild | The reference node, i.e., the node before which the new node must be inserted.
Returns: The node being inserted. Reimplemented from XalanDocument.

bool Stylesheet::isAttrOK ( | const XalanDOMChar * attrName,
| const AttributeListType & atts,
| int which,
| StylesheetConstructionContext & constructionContext ) const

  | See if this is a xmlns attribute, and, if so, process it. Parameters:
  attrName | qualified name of attribute
  atts | attribute list where the element comes from (not used at this time)
  which | index into the attribute list (not used at this time)
Returns: true if this is a namespace name

bool Stylesheet::isIndexed ( | ) const`[virtual]`

| Determine if the document is node-order indexed. Returns: true if the document is indexed, otherwise false. Reimplemented from XalanDocument.

bool Stylesheet::isRoot ( | ) const

| Tell if this is the root of the stylesheet tree. Returns: true if it is the root

bool Stylesheet::isSupported ( | const XalanDOMString & feature,
| const XalanDOMString & version ) const`[virtual]`

  | Tests whether the DOM implementation implements a specific feature and that feature is supported by this node. Parameters:
  feature | The string of the feature to test. This is the same name as what can be passed to the method `hasFeature` on `DOMImplementation`.
  version | This is the version number of the feature to test. In Level 2, version 1, this is the string "2.0". If the version is not specified, supporting any version of the feature will cause the method to return `true`.
Returns: Returns `true` if the specified feature is supported on this node, `false` otherwise. Reimplemented from XalanDocument.

bool Stylesheet::isWrapperless ( | ) const

| whether there is a wrapper template. Returns: true is there is a wrapper

const PatternTableVectorType * Stylesheet::locateAttributeMatchPatternList2 ( | const XalanDOMString & theName ) const

  | Given a name, locate the start of a list of possible templates that match that name. If none match, then use the default list. Parameters:
  theName | The name to match

const PatternTableVectorType * Stylesheet::locateElementMatchPatternList2 ( | const XalanDOMString & theName ) const

  | Given a name, locate the start of a list of possible templates that match that name. If none match, then use the default list. Parameters:
  theName | The name to match

const PatternTableVectorType * Stylesheet::locateMatchPatternList2 ( | const XalanNode & theNode,
| XalanNode::NodeType targetNodeType ) const

  | Given a XalanNode, locate the start of a list of possible templates that match it. Parameters:
  XalanNode | The node to match

ExtensionNSHandler * Stylesheet::lookupExtensionNSHandler ( | const XalanDOMString & uri ) const

  | Return the handler for a given extension namespace. Parameters:
  uri | the URI of the extension namespace.
Returns: pointer to extension handler

void Stylesheet::normalize ( | )`[virtual]`

| Puts all `Text` nodes in the full depth of the sub-tree underneath this `Node`, including attribute nodes, into a "normal" form where only markup (e.g., tags, comments, processing instructions, CDATA sections, and entity references) separates `Text` nodes, i.e., there are no adjacent `Text` nodes. This can be used to ensure that the DOM view of a document is the same as if it were saved and re-loaded, and is useful when operations (such as XPointer lookups) that depend on a particular document tree structure are to be used. Note: In cases where the document contains `CDATASections`, the normalize operation alone may not be sufficient, since XPointers do not differentiate between `Text` nodes and `CDATASection` nodes. Reimplemented from XalanDocument.

void Stylesheet::popNamespaces ( | )

| Pop a namespace declaration from the namespace stack.

void Stylesheet::postConstruction ( | StylesheetConstructionContext & constructionContext )`[virtual]`

| Called after construction is completed. Reimplemented in StylesheetRoot.

void Stylesheet::processDecimalFormatElement ( | StylesheetConstructionContext & constructionContext,
| const AttributeListType & atts,
| const LocatorType * locator = 0 )

  | Process an xsl:decimal-format element. Parameters:
  elemDecimalFormat | the element

void Stylesheet::processExcludeResultPrefixes ( | StylesheetConstructionContext & theConstructionContext,
| const XalanDOMChar * theValue )

  | See if a namespace should be excluded. Parameters:
  theConstructionContext | the current construction context.
  theValue | the prefix of the namespace.
Returns:

void Stylesheet::processExtensionNamespace ( | StylesheetConstructionContext & theConstructionContext,
| const XalanDOMString & uri )

  | Add an extension namespace handler. This provides methods for calling an element extension as well as for function calls (which is passed on to XPath). Parameters:
  constructionContext | The current construction context.
  uri | The namespace URI of the extension.

void Stylesheet::processKeyElement ( | const PrefixResolver & nsContext,
| const AttributeListType & atts,
| const LocatorType * locator,
| StylesheetConstructionContext & constructionContext )

  | Process the xsl:key element. Parameters:
  nsContext | The PrefixResolver instance for namespace prefixes.
  atts | The attribute list for element. param locator The Locator instance for error reporting, if any. May be 0.
  constructionContext | The current construction context.

void Stylesheet::processNSAliasElement ( | const XalanDOMChar * name,
| const AttributeListType & atts,
| StylesheetConstructionContext & constructionContext )

  | Process an xsl:namespace-alias element. Parameters:
  name | the element name.
  attrs | the current attribute list
  constructionContext | the active construction context

void Stylesheet::pushNamespaces ( | const AttributeListType & atts )

  | Push the namespace declarations from the current attribute list onto the namespace stack. Parameters:
  atts | attribute list constaining namespaces

void Stylesheet::pushTopLevelVariables ( | StylesheetExecutionContext & executionContext,
| const ParamVectorType & topLevelParams ) const

  | Set a list of top level variables in the specified execution context stylesheet. Parameters:
  executionContext | current execution context
  topLevelParams | list of top level parameters

XalanNode * Stylesheet::removeChild ( | XalanNode * oldChild )`[virtual]`

  | Removes the child node indicated by `oldChild` from the list of children, and returns it. Parameters:
  oldChild | The node being removed.
Returns: The node removed. Reimplemented from XalanDocument.

XalanNode * Stylesheet::replaceChild ( | XalanNode * newChild,
| XalanNode * oldChild )`[virtual]`

  | Replaces the child node `oldChild` with `newChild` in the list of children, and returns the `oldChild` node. If `newChild` is a `DocumentFragment` object, `oldChild` is replaced by all of the `DocumentFragment` children, which are inserted in the same order. If the `newChild` is already in the tree, it is first removed. Parameters:
  newChild | The new node to put in the child list.
  oldChild | The node being replaced in the list.
Returns: The node replaced. Reimplemented from XalanDocument.

void Stylesheet::setBaseIdentifier ( | const XalanDOMString & str )

  | Set the base identifier with which this stylesheet is associated. Parameters:
  str | string for base identifier

void Stylesheet::setNamespaceDecls ( | const NamespaceVectorType & ns )

  | Set the list of namespace declarations currently in effect. Parameters:
  ns | vector of namespace vectors

void Stylesheet::setNodeValue ( | const XalanDOMString & nodeValue )`[virtual]`

| Sets the value of the node. Any node which can have a nodeValue ( See also: getNodeValue) will also accept requests to set it to a string. The exact response to this varies from node to node -- Attribute, for example, stores its values in its children and has to replace them with a new Text holding the replacement value. For most types of Node, value is null and attempting to set it will throw DOMException(NO_MODIFICATION_ALLOWED_ERR). This will also be thrown if the node is read-only. Reimplemented from XalanDocument.

void Stylesheet::setPrefix ( | const XalanDOMString & prefix )`[virtual]`

  | Set the namespace prefix of this node. Note that setting this attribute, when permitted, changes the `nodeName` attribute, which holds the qualified name, as well as the `tagName` and `name` attributes of the `Element` and `Attr` interfaces, when applicable. Note also that changing the prefix of an attribute, that is known to have a default value, does not make a new attribute with the default value and the original prefix appear, since the `namespaceURI` and `localName` do not change. Parameters:
  prefix | The prefix of this node.
  Exceptions:
  DOMException | INVALID_CHARACTER_ERR: Raised if the specified prefix contains an illegal character. NO_MODIFICATION_ALLOWED_ERR: Raised if this node is readonly. NAMESPACE_ERR: Raised if the specified `prefix` is malformed, if the specified prefix is "xml" and the `namespaceURI` of this node is different from "http://www.w3.org/XML/1998/namespace", if specified prefix is "xmlns" and the `namespaceURI` is neither `null` nor an empty string, or if the `localName` is `null`.
Reimplemented from XalanDocument.

void Stylesheet::setTopLevelVariable ( | ElemVariable * var )

  | Set a top level variable. Parameters:
  var | top-level variable declared with "xsl:variable" or xsl:param-variable.

void Stylesheet::setXSLTNamespaceURI ( | const XalanDOMString & theURI )

void Stylesheet::setXSLTVerDeclared ( | double ver )

  | Set XSLT version number. Parameters:
  ver | number representing XSLT version

## Member Data Documentation

XalanDOMString Stylesheet::m_baseIdent`[protected]`

| The base URL of the XSL document.

KeyDeclarationVectorType Stylesheet::m_keyDeclarations`[protected]`

| Table of KeyDeclaration objects, which are set by the xsl:key element.

StylesheetRoot & Stylesheet::m_stylesheetRoot`[protected]`

| The root of the stylesheet tree.

const XalanQNameByReference Stylesheet::s_emptyQName`[static, protected]`

The documentation for this class was generated from the following file:

- Stylesheet.hpp

Interpreting class diagrams

Doxygen and GraphViz are used to generate this API documentation from the Xalan-C header files.

Xalan-C++ XSLT Processor Version 1.5 Copyright © 2000, 2001, 2002, 2003 The Apache Software Foundation. All Rights Reserved.